from flask import Flask, render_template, request, url_for, redirect
from DbClass import DbClass
import uuid
import hashlib
import os

app = Flask(__name__)

@app.route('/')
def index():
    return render_template('login.html')
@app.route('/login', methods=["POST"])
def login():
    db = DbClass()
    username = request.form['Username']
    password = request.form['Password']
    hashed_wachtwoord = db.login(username)
    print(hashed_wachtwoord)
    if check_password(hashed_wachtwoord[0], password):
        return redirect(url_for('homepage'))
    else:
        return render_template("login.html")
@app.route('/logout')
def logout():
    return redirect(url_for('index'))
@app.route('/register')
def register():
    return render_template('register.html')
@app.route('/registration', methods=["POST"])
def registration():
    db = DbClass()
    username = request.form['Username']
    email = request.form['Email']
    password = request.form['Password']
    hashed_password = hash_password(password)
    db.registration(username, email, hashed_password)
    return redirect(url_for('homepage'))
@app.route('/homepage')
def homepage():
    db = DbClass()
    lstData = db.homepageGewichtOphalen()
    for waarde in lstData:
        data=waarde
    return render_template('homepage.html', lstData=str(data[0]))
@app.route('/schedules')
def schedules():
    db = DbClass()
    lstData = db.schedulesDataOphalen()
    breakfast = str(lstData[0])
    lunch = str(lstData[1])
    dinner = str(lstData[2])
    return render_template('schedules.html', breakfast=str(breakfast[1:4]), lunch=str(lunch[1:4]), dinner=str(dinner[1:3]))
@app.route('/data')
def data():
    db = DbClass()
    lstData = db.dataOphalen()
    return render_template('data.html', lstData=lstData)

@app.route('/settingsOpslaan', methods=["POST"])
def settingsOpslaan():
    db = DbClass()
    namePet = request.form['NamePet']
    weightPet = request.form['WeightPet']
    db.settingsOpslaan(namePet, weightPet)
    return render_template('settings.html', namePet=namePet, weightPet=weightPet)
@app.route('/settings')
def settings():
    return render_template('settings.html')

#PASSWORD HASHING AND DEHASHING
def hash_password(password):
    # uuid is used to generate a random number
    salt = uuid.uuid4().hex
    return hashlib.sha256(salt.encode() + password.encode()).hexdigest() + ':' + salt
def check_password(hashed_password, user_password):
    password, salt = hashed_password.split(':')
    return password == hashlib.sha256(salt.encode() + user_password.encode()).hexdigest()

#CSS REFRESHER
@app.context_processor
def override_url_for():
    return dict(url_for=dated_url_for)
def dated_url_for(endpoint, **values):
    if endpoint == 'static':
        filename = values.get('filename', None)
        if filename:
            file_path = os.path.join(app.root_path,
                                     endpoint, filename)
            values['q'] = int(os.stat(file_path).st_mtime)
    return url_for(endpoint, **values)

if __name__ == '__main__':
    port = int(os.environ.get("PORT", 8080))
    host = "0.0.0.0"
    app.run(host=host, port=port, debug=True)
